#include "ti82.h"
#include "keys.inc"

   .org START_ADDR
   .db  "Maclaurin Series",0
  
start:
  call sub0
  ld   hl,text1
  call sub1
  ld   hl,text2
  call sub2
  ld   hl,text3
  call sub4
  ld   hl,text4
  call sub6
  ld   hl,text5
  call sub7
  ld   hl,text6
  ROM_CALL(D_ZT_STR)

geta:
  call GET_KEY
  cp   G_ENTER
  jp   z,label_y
  jr   geta
    
label_y:
  call sub0
  ld   hl,text7
  call sub1
  ld   hl,text8
  call sub2
  ld   hl,text9
  call sub3
  ld   hl,text10
  call sub4
  ld   hl,text11
  call sub7
  ld   hl,text14
  ROM_CALL(D_ZT_STR)
   
get1:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_a
  cp   G_WINDOW
  jp   z,label_b
  cp   G_ZOOM
  jp   z,label_c
  cp   G_TRACE
  jp   z,label_d
  cp   G_GRAPH
  jp   z,label_x
  cp   G_CLEAR
  jp   z,label_z
  jr   get1
  
label_a:
  call sub0
  ld   hl,text12
  call sub1
  ld   hl,text13
  call sub2
  ld   hl,text15
  call sub3
  ld   hl,text16
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
    
get2:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_y
  cp   G_CLEAR
  jp   z,label_z
  jr   get2

label_b:
  call sub0
  ld   hl,text18
  call sub1
  ld   hl,text19
  call sub2
  ld   hl,text20
  call sub3
  ld   hl,text21
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
  jr   get2

label_c:
  call sub0
  ld   hl,text23
  call sub1
  ld   hl,text24
  call sub2
  ld   hl,text25
  call sub3
  ld   hl,text26
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
  jr   get2
  
label_d:
  call sub0
  ld   hl,text28
  call sub1
  ld   hl,text29
  call sub2
  ld   hl,text30
  call sub3
  ld   hl,text31
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
  jr   get2
  
label_x:
  call sub0
  ld   hl,text49
  call sub1
  ld   hl,text50
  call sub2
  ld   hl,text51
  call sub3
  ld   hl,text52
  call sub7
  ld   hl,text54
  ROM_CALL(D_ZT_STR)
  
get6:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_e
  cp   G_WINDOW
  jp   z,label_f
  cp   G_ZOOM
  jp   z,label_g
  cp   G_TRACE
  jp   z,label_y
  cp   G_CLEAR
  jp   z,label_z
  jr   get6
  
label_e:
  call sub0
  ld   hl,text33
  call sub1
  ld   hl,text34
  call sub2
  ld   hl,text35
  call sub3
  ld   hl,text36
  call sub4
  ld   hl,text37
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
   
get7:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_x
  cp   G_CLEAR
  jp   z,label_z
  jr   get7

label_f:
  call sub0
  ld   hl,text39
  call sub1
  ld   hl,text40
  call sub2
  ld   hl,text41
  call sub3
  ld   hl,text42
  call sub4
  ld   hl,text43
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
  jr   get7

label_g:
  call sub0
  ld   hl,text44
  call sub1
  ld   hl,text45
  call sub2
  ld   hl,text46
  call sub3
  ld   hl,text47
  call sub4
  ld   hl,text48
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
  jr   get7  

sub0:
  ROM_CALL(CLEARLCD)
  ld   de,$0000
  ld   (CURSOR_ROW),de
  ret

sub1:
  ROM_CALL(D_ZT_STR)
  ld   de,$0001
  ld   (CURSOR_ROW),de
  ret

sub2:
  ROM_CALL(D_ZT_STR)
  ld   de,$0002
  ld   (CURSOR_ROW),de
  ret

sub3:
  ROM_CALL(D_ZT_STR)
  ld   de,$0003
  ld   (CURSOR_ROW),de
  ret

sub4:
  ROM_CALL(D_ZT_STR)
  ld   de,$0004
  ld   (CURSOR_ROW),de
  ret

sub5:
  ROM_CALL(D_ZT_STR)
  ld   de,$0005
  ld   (CURSOR_ROW),de
  ret

sub6:
  ROM_CALL(D_ZT_STR)
  ld   de,$0006
  ld   (CURSOR_ROW),de
  ret

sub7:
  ROM_CALL(D_ZT_STR)
  ld   de,$0007
  ld   (CURSOR_ROW),de
  ret

label_z:
  ret

text1:
.db "MACLAURIN",0
text2:
.db "SERIES",0
text3:
.db "V1.0",0
text4:
.db "(C) 2002",0
text5:
.db "WILSON NG",0
text6:
.db "WAESH@YAHOO",0
text7:
.db "1) 1/1-X",0
text8:
.db "2) 1/1+X",0
text9:
.db "3) e^X",0
text10:
.db "4) SIN X",0
text11:
.db "5) MORE",0
text14:
.db " 1  2   3  4  5",0

text12:
.db "1/1-X",0
text13:
.db "1+X+X?+...X^N...",0
text15:
.db "X^N,N=0-INF,",0
text16:
.db "abs X<1",0
text17:
.db "BACK",0

text18:
.db "1/1+X",0
text19:
.db "1-X+X?-...(-1)^N",0
text20:
.db "X^N,N=0-INF,",0
text21:
.db "abs X<1",0

text23:
.db "e^X",0
text24:
.db "1+X+X?/2!+...",0
text25:
.db "X^N/N!,N=0-INF,",0
text26:
.db "ALL REAL X",0

text28:
.db "SIN X",0
text29:
.db "X-X^3/3!+X^5/5!-",0
text30:
.db ".(-1)^N(X^(2N+1)",0
text31:
.db ",ALL REAL X",0

text33:
.db "COS X",0
text34:
.db "1-X?/2!+X^4/4!-",0
text35:
.db ".(-1)^N(X^2N)/",0
text36:
.db "(2N)!,N=0-INF",0
text37:
.db ",ALL REAL X",0

text39:
.db "LN 1+X",0
text40:
.db "X-X?/2+X^3/3-..",0
text41:
.db "(-1 )^(N-1)(X^N)",0
text42:
.db "/N,N=1-INF,",0
text43:
.db "-1<X1",0

text44:
.db "TAN-1",0
text45:
.db "X-X^3/3+X^5/5-..",0
text46:
.db "(-1)^N(X^(2N+1))",0
text47:
.db "/(2N+1),N=0-INF",0
text48:
.db ", abs X1",0

text49:
.db "6) COS X",0
text50:
.db "7) LN 1+X",0
text51:
.db "8) TAN-1",0
text52:
.db "9) BACK",0
text54:
.db " 6  7   8  9",0

.end

